<?php

declare(strict_types=1);

namespace App\Policies;

use Illuminate\Foundation\Auth\User as AuthUser;
use App\Models\TopUp;
use Illuminate\Auth\Access\HandlesAuthorization;

class TopUpPolicy
{
    use HandlesAuthorization;
    
    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:TopUp');
    }

    public function view(AuthUser $authUser, TopUp $topUp): bool
    {
        return $authUser->can('View:TopUp');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:TopUp');
    }

    public function update(AuthUser $authUser, TopUp $topUp): bool
    {
        return $authUser->can('Update:TopUp');
    }

    public function delete(AuthUser $authUser, TopUp $topUp): bool
    {
        return $authUser->can('Delete:TopUp');
    }

    public function restore(AuthUser $authUser, TopUp $topUp): bool
    {
        return $authUser->can('Restore:TopUp');
    }

    public function forceDelete(AuthUser $authUser, TopUp $topUp): bool
    {
        return $authUser->can('ForceDelete:TopUp');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:TopUp');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:TopUp');
    }

    public function replicate(AuthUser $authUser, TopUp $topUp): bool
    {
        return $authUser->can('Replicate:TopUp');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:TopUp');
    }

}